行为变更:以 Android 15 或更高版本为目标平台的应用

与以前的版本一样,Android 15 包含一些行为变更,这些变更可能会影响您的应用。以下行为变更仅影响以 Android 15 或更高版本为目标平台的应用。如果您的应用以 Android 15 或更高版本为目标平台,您应该修改自己的应用以适当地支持这些行为(如果适用)。

此外,请务必查看对 Android 15 上运行的所有应用都有影响的行为变更列表(无论应用的 targetSdkVersion 如何)。

核心功能

Android 15 修改或扩展了 Android 系统的各种核心功能。

前台服务的变更

我们将对 Android 15 中的前台服务做出以下更改。

数据同步前台服务超时行为

Android 15 针对以目标平台为目标平台的应用为 dataSync 引入了新的超时行为 Android 15 或更高版本。这一行为也适用于新的 mediaProcessing 前台服务类型

系统允许应用的 dataSync 服务总共运行 6 小时 之后,系统会调用正在运行的服务的 Service.onTimeout(int, int) 方法(在 Android 中引入) 15)。此时,服务有几秒钟的时间来调用 Service.stopSelf().调用 Service.onTimeout() 时, 服务不再被视为前台服务。如果该服务没有 调用 Service.stopSelf() 时,系统会抛出内部异常。通过 Logcat 中会记录以下异常:

Fatal Exception: android.app.RemoteServiceException: "A foreground service of
type dataSync did not stop within its timeout: [component name]"

为避免这种行为变更出现问题,您可以执行下列一项或多项操作 以下:

  1. 让您的服务实现新的 Service.onTimeout(int, int) 方法。 当您的应用收到回调时,请务必在stopSelf() 几秒。(如果您不立即停止应用,则系统会生成 失败。)
  2. 确保应用的 dataSync 服务运行的总时间不超过 在任何 24 小时内为 6 小时(除非用户与应用互动; 重置计时器)。
  3. 仅在用户执行直接操作后启动 dataSync 项前台服务 互动;由于服务启动时您的应用位于前台 您的服务在应用转入后台后的完整运行 6 小时。
  4. 请不要使用 dataSync 前台服务,而应使用 替代 API

如果您的应用的 dataSync 前台服务在过去 6 小时内运行过 24,除非用户dataSync 已将您的应用调到前台(这会重置计时器)。如果您尝试 启动另一个 dataSync 前台服务时,系统会抛出 ForegroundServiceStartNotAllowedException 并显示类似“前台服务的时限已用尽”的错误消息 type dataSync”。

测试

如需测试应用的行为,您可以启用数据同步超时(即使应用也是如此) 未以 Android 15 为目标平台(只要应用在 Android 15 上运行即可) 设备)。如需启用超时功能,请运行以下 adb 命令:

adb shell am compat enable FGS_INTRODUCE_TIME_LIMITS your-package-name

您还可以调整超时期限,以便更轻松地测试 在达到该限制时,应用的行为。要设置新的超时期限,请运行 以下 adb 命令:

adb shell device_config put activity_manager data_sync_fgs_timeout_duration duration-in-milliseconds

新增媒体处理前台服务类型

Android 15 引入了一种新的前台服务类型,即 mediaProcessing。此服务类型适用于对媒体文件进行转码等操作。例如,媒体应用可能会下载音频文件,并需要将其转换为其他格式才能播放。您可以使用 mediaProcessing 前台服务,确保即使应用在后台运行时转换也会继续。

系统允许应用的 mediaProcessing 服务在 24 小时内共运行 6 小时,之后系统会调用正在运行的服务的 Service.onTimeout(int, int) 方法(在 Android 15 中引入)。此时,该服务有几秒钟时间来调用 Service.stopSelf()。如果服务未调用 Service.stopSelf(),系统会抛出内部异常。系统会在 Logcat 中记录异常,并显示以下消息:

Fatal Exception: android.app.RemoteServiceException: "A foreground service of
type mediaProcessing did not stop within its timeout: [component name]"

为避免出现异常,您可以执行以下操作之一:

  1. 让您的服务实现新的 Service.onTimeout(int, int) 方法。当应用收到回调时,请务必在几秒钟内调用 stopSelf()。(如果您不立即停止应用,系统会生成故障。)
  2. 确保应用的 mediaProcessing 服务在任何 24 小时内的运行时间都不超过 6 小时(除非用户与应用互动并重置计时器)。
  3. 仅通过直接的用户互动来启动 mediaProcessing 前台服务;由于您的应用在服务启动时位于前台,因此服务会在应用进入后台后的 6 小时内完整运行。
  4. 请使用替代 API(例如 WorkManager),而不是使用 mediaProcessing 前台服务。

如果您的应用的 mediaProcessing 前台服务在过去 24 天内运行了 6 个小时,除非用户将您的应用调到前台(这会重置计时器),否则您无法启动其他 mediaProcessing 前台服务。如果您尝试启动另一个 mediaProcessing 前台服务,系统会抛出 ForegroundServiceStartNotAllowedException,并显示类似“Time limit already exhausted for the service type mediaProcessing”之类的错误消息。

如需详细了解 mediaProcessing 服务类型,请参阅 Android 15 前台服务类型的变更:媒体处理

测试

如需测试应用的行为,即使您的应用并非以 Android 15 为目标平台(只要该应用在 Android 15 设备上运行),您也可以启用媒体处理超时。如需启用超时功能,请运行以下 adb 命令:

adb shell am compat enable FGS_INTRODUCE_TIME_LIMITS your-package-name

您还可以调整超时期限,更轻松地测试应用在达到此限制时的行为。如需设置新的超时期限,请运行以下 adb 命令:

adb shell device_config put activity_manager media_processing_fgs_timeout_duration duration-in-milliseconds

对启动前台服务的 BOOT_COMPLETED 广播接收器的限制

在启动 BOOT_COMPLETED 广播接收器方面存在新限制 前台服务。BOOT_COMPLETED 接收器能启动 以下前台服务类型:

如果 BOOT_COMPLETED 接收器尝试启动任何上述类型的前台 服务,系统会抛出 ForegroundServiceStartNotAllowedException

测试

如需测试应用的行为,即使您的 应用并非以 Android 15 为目标平台(只要该应用在 Android 15 上运行即可) 设备)。运行以下 adb 命令:

adb shell am compat enable FGS_BOOT_COMPLETED_RESTRICTIONS your-package-name

如需在不重启设备的情况下发送 BOOT_COMPLETED 广播, 运行以下 adb 命令:

adb shell am broadcast -a android.intent.action.BOOT_COMPLETED your-package-name

限制在应用拥有 SYSTEM_ALERT_WINDOW 权限的情况下启动前台服务

Previously, if an app held the SYSTEM_ALERT_WINDOW permission, it could launch a foreground service even if the app was currently in the background (as discussed in exemptions from background start restrictions).

If an app targets Android 15, this exemption is now narrower. The app now needs to have the SYSTEM_ALERT_WINDOW permission and also have a visible overlay window. That is, the app needs to first launch a TYPE_APPLICATION_OVERLAY window and the window needs to be visible before you start a foreground service.

If your app attempts to start a foreground service from the background without meeting these new requirements (and it does not have some other exemption), the system throws ForegroundServiceStartNotAllowedException.

If your app declares the SYSTEM_ALERT_WINDOW permission and launches foreground services from the background, it may be affected by this change. If your app gets a ForegroundServiceStartNotAllowedException, check your app's order of operations and make sure your app already has an active overlay window before it attempts to start a foreground service from the background. You can check if your overlay window is currently visible by calling View.getWindowVisibility(), or you can override View.onWindowVisibilityChanged() to get notified whenever the visibility changes.

Testing

To test your app's behavior, you can enable these new restrictions even if your app is not targeting Android 15 (as long as the app is running on an Android 15 device). To enable these new restrictions on starting foreground services from the background, run the following adb command:

adb shell am compat enable FGS_SAW_RESTRICTIONS your-package-name

更改了应用何时可以修改勿扰模式的全局状态

以 Android 15 为目标平台的应用无法再更改设备上的全局状态或勿扰 (DND) 政策(通过修改用户设置或关闭 DND 模式)。相反,应用必须提供一个 AutomaticZenRule,系统会将后者合并到一个具有现有最严格的政策胜出方案的全局政策中。调用之前影响全局状态的现有 API(setInterruptionFiltersetNotificationPolicy)会导致创建或更新隐式 AutomaticZenRule,该 AutomaticZenRule 根据这些 API 调用的调用周期而开启或关闭。

请注意,只有在应用调用 setInterruptionFilter(INTERRUPTION_FILTER_ALL) 且预期调用会停用之前由其所有者激活的 AutomaticZenRule 时,此变更才会影响可观察的行为。

OpenJDK API 变更

Android 15 将继续更新 Android 的核心库, 最新 OpenJDK LTS 版本中的功能。

其中一些变更可能会影响应用定位的应用兼容性 Android 15(API 级别 35):

  • 字符串格式设置 API 变更:验证参数索引、标志、 现在,使用 String.format()Formatter.format() API:

    例如,当参数索引为 0 时,会抛出以下异常 (格式字符串中的 %0):

    IllegalFormatArgumentIndexException: Illegal format argument index = 0
    

    在这种情况下,可以使用参数索引为 1 (%1 )。

  • Arrays.asList(...).toArray() 组件类型的更改:使用 Arrays.asList(...).toArray(),则所得数组的组件类型为 现在是 Object,而不是底层数组元素的类型。因此, 以下代码会抛出 ClassCastException

    String[] elements = (String[]) Arrays.asList("one", "two").toArray();
    

    在本例中,在结果中将 String 保留为组件类型 数组,您可以改用 Collection.toArray(Object[])

    String[] elements = Arrays.asList("two", "one").toArray(new String[0]);
    
  • 语言代码处理方式变更:使用 Locale API 时, 不再转换希伯来语、意第绪语和印度尼西亚语的语言代码 对应的过时形式(希伯来语:iw、意第绪语:ji 和印度尼西亚语:in)。 在为其中某个语言区域指定语言代码时,请使用代码 改为 ISO 639-1(希伯来语:he,意第绪语:yi,印度尼西亚语:id)。

  • 对随机整数序列的更改https://bugs.openjdk.org/browse/JDK-8301574,下面 Random.ints() 方法现在返回的数值序列与 Random.nextInt() 方法的用途如下:

    一般来说,此变更不会导致应用中断行为,但您的 代码不应期望 Random.ints() 方法生成的序列 匹配Random.nextInt()

新的 SequencedCollection API 可能会影响应用的兼容性 当您在应用的 build 配置中更新 compileSdk 以使用 Android 15(API 级别 35)

  • MutableList.removeFirst()kotlin-stdlib 中的 MutableList.removeLast() 扩展函数

    Java 中的 List 类型会映射到 Kotlin 中的 MutableList 类型。 由于使用 List.removeFirst()List.removeLast() API 已在 Android 15(API 级别 35)中引入,Kotlin 编译器 将函数调用(例如 list.removeFirst())静态解析为 新的 List API,而不是对 API 中的扩展函数 kotlin-stdlib

    重新编译应用时,如果 compileSdk 设为 35,并且 minSdk 设为 34 或更低版本,那么应用会在 Android 14 及更低版本(运行时)上运行 错误:

    java.lang.NoSuchMethodError: No virtual method
    removeFirst()Ljava/lang/Object; in class Ljava/util/ArrayList;
    

    Android Gradle 插件中的现有 NewApi lint 选项可以捕获这些 新的 API 用法。

    ./gradlew lint
    
    MainActivity.kt:41: Error: Call requires API level 35 (current min is 34): java.util.List#removeFirst [NewApi]
          list.removeFirst()
    

    如需修复运行时异常和 lint 错误,removeFirst()removeLast() 函数调用可替换为 removeAt(0)removeAt(list.lastIndex)(在 Kotlin 中分别对应)。如果您使用的是 Android Studio Ladybug |2024.1.3 或更高版本,也提供快速修复 处理这些错误的选项

    如果 lint 选项已停用,请考虑移除 @SuppressLint("NewApi")lintOptions { disable 'NewApi' }

  • 与 Java 中的其他方法冲突

    向现有类型中添加了新方法,例如, ListDeque。这些新方法 其他接口中具有相同名称和参数类型的方法 和类。如果与 不兼容,javac 编译器会输出构建时错误。例如:

    错误 1 示例:

    javac MyList.java
    
    MyList.java:135: error: removeLast() in MyList cannot implement removeLast() in List
      public void removeLast() {
                  ^
      return type void is not compatible with Object
      where E is a type-variable:
        E extends Object declared in interface List
    

    错误 2 示例:

    javac MyList.java
    
    MyList.java:7: error: types Deque<Object> and List<Object> are incompatible;
    public class MyList implements  List<Object>, Deque<Object> {
      both define reversed(), but with unrelated return types
    1 error
    

    错误 3 示例:

    javac MyList.java
    
    MyList.java:43: error: types List<E#1> and MyInterface<E#2> are incompatible;
    public static class MyList implements List<Object>, MyInterface<Object> {
      class MyList inherits unrelated defaults for getFirst() from types List and MyInterface
      where E#1,E#2 are type-variables:
        E#1 extends Object declared in interface List
        E#2 extends Object declared in interface MyInterface
    1 error
    

    要修复这些构建错误,实现这些接口的类应 使用兼容的返回值类型替换该方法。例如:

    @Override
    public Object getFirst() {
        return List.super.getLast();
    }
    

安全

Android 15 包含一些有助于提升系统安全性的变更,以帮助保护应用和用户免受恶意应用的侵害。

限制后台 activity 启动

Android 15 通过添加变更来防止恶意后台应用将其他应用带到前台、提升其权限和滥用用户互动,从而保护用户免受恶意应用的侵害,并使用户能够更好地控制其设备。从 Android 10(API 级别 29)开始,后台 activity 启动已受到限制。

阻止与堆栈中顶部 UID 不匹配的应用启动 activity

恶意应用可以在同一任务内启动另一个应用的 activity,然后叠加在上面,制造出作为该应用的错觉。这种“任务劫持”攻击绕过了当前的后台启动限制,因为它都发生在同一可见任务内。为了降低这种风险,Android 15 添加了一个标志,用于阻止与堆栈上的顶级 UID 不匹配的应用启动 activity。如需选择启用应用的所有 activity,请更新应用的 AndroidManifest.xml 文件中的 allowCrossUidActivitySwitchFromBelow 属性:

<application android:allowCrossUidActivitySwitchFromBelow="false" >

如果满足以下所有条件,则新的安全措施就会生效:

  • 执行启动的应用以 Android 15 为目标平台。
  • 任务堆栈顶部的应用以 Android 15 为目标平台。
  • 所有可见的活动均已启用新版保护措施

如果启用了安全措施,应用如果完成自己的任务,可能会返回主屏幕,而不是返回上一个可见的应用。

其他变更

除了 UID 匹配的限制之外,还包含以下其他更改:

  • PendingIntent 创建者更改为默认阻止后台 activity 启动。这有助于防止应用意外创建可能会被恶意操作者滥用的 PendingIntent
  • 请勿将应用置于前台,除非 PendingIntent 发送者允许该应用。此变更旨在防止恶意应用滥用在后台启动 activity 的功能。默认情况下,不允许应用将任务堆栈置于前台,除非创建者允许后台 activity 启动特权或发送者具有后台 activity 启动特权。
  • 控制任务堆栈的顶层 activity 完成其任务的方式。如果顶层 activity 完成某项任务,Android 会返回到上次处于活动状态的任务。此外,如果非顶层 activity 完成其任务,Android 将返回主屏幕;它不会阻止此非顶部 activity 的完成。
  • 防止将其他应用中的任意 activity 启动到您自己的任务中。这项变更会通过创建看似来自其他应用的活动,防止恶意应用向用户进行钓鱼式攻击。
  • 阻止系统考虑将不可见窗口用于后台 activity 启动。这有助于防止恶意应用滥用后台 activity 启动来向用户显示不受欢迎或恶意内容。

更安全的 intent

Android 15 引入了新的安全措施,使 intent 更加安全可靠。这些变更旨在防止潜在漏洞和被恶意应用利用的 intent 滥用。Android 15 中对 intent 的安全性进行了两项主要改进:

  • 匹配目标 intent 过滤器:定位特定组件的 intent 必须准确匹配目标的 intent 过滤器规范。如果您通过发送 intent 来启动其他应用的 activity,则目标 intent 组件需要与接收 activity 声明的 intent 过滤器保持一致。
  • intent 必须具有操作:没有操作的 intent 将不再与任何 intent 过滤器匹配。这意味着,用于启动 activity 或服务的 intent 必须具有明确定义的操作。
  • 待处理 intent:待处理 intent 的创建者被视为封装 intent 的发送者,而非待处理 intent 的发送者

Kotlin


fun onCreate() {
    StrictMode.setVmPolicy(VmPolicy.Builder()
        .detectUnsafeIntentLaunch()
        .build()
    )
}

Java


public void onCreate() {
    StrictMode.setVmPolicy(new VmPolicy.Builder()
            .detectUnsafeIntentLaunch()
            .build());
}

用户体验和系统界面

Android 15 包含一些旨在打造更一致、更直观的用户体验的变更。

窗口边衬区更改

Android 15 中有两个与窗口边衬区相关的变更:默认强制执行无边框模式;还存在配置变更,例如系统栏的默认配置。

全面强制执行

在搭载 Android 15 的设备上,应用会默认采用全屏 以 Android 15(API 级别 35)为目标平台。

<ph type="x-smartling-placeholder">
</ph>
一款以 Android 14 为目标平台且在 Android 设备上未处于无边框的应用 Android 15 设备。


<ph type="x-smartling-placeholder">
</ph>
一款以 Android 15(API 级别 35)为目标平台且采用无边框的应用 在 Android 15 设备上。此应用主要使用 Material 3 Compose 组件 自动应用边衬区此屏幕不会受到 Android 15 全屏强制执行。

这是一项可能会对应用的界面产生负面影响的破坏性更改。通过 更改会影响以下界面区域:

  • 手势手柄导航栏 <ph type="x-smartling-placeholder">
      </ph>
    • 默认透明。
    • 底部偏移量已停用,因此内容绘制在系统导航栏后面 栏。
    • setNavigationBarColorR.attr#navigationBarColor 已弃用,不会影响手势导航。
    • setNavigationBarContrastEnforcedR.attr#navigationBarContrastEnforced不会对 手势导航。
  • “三按钮”导航 <ph type="x-smartling-placeholder">
      </ph>
    • 默认不透明度设为 80%,颜色可能与窗口一致 背景。
    • 底部偏移值已停用,因此内容绘制在系统导航栏后面 除非应用了边衬区。
    • setNavigationBarColorR.attr#navigationBarColor 默认设置为与窗口背景匹配。窗口背景 必须是颜色可绘制对象,才能应用此默认值。此 API 是 但会继续影响“三按钮”导航。
    • setNavigationBarContrastEnforcedR.attr#navigationBarContrastEnforced 默认为 true,这会添加一个 “三按钮”导航模式显示 80% 不透明的背景。
  • 状态栏 <ph type="x-smartling-placeholder">
      </ph>
    • 默认透明。
    • 顶部偏移量已停用,因此除非 边衬区。
    • setStatusBarColorR.attr#statusBarColor 已废弃,对 Android 15 没有任何影响。
    • setStatusBarContrastEnforcedR.attr#statusBarContrastEnforced 已弃用,但仍具有 对 Android 15 的影响。
  • 刘海屏 <ph type="x-smartling-placeholder">
      </ph>
    • layoutInDisplayCutoutMode 的非浮动窗口必须是 LAYOUT_IN_DISPLAY_CUTOUT_MODE_ALWAYS.SHORT_EDGESNEVER和 系统会将 DEFAULT 解读为 ALWAYS,这样用户就不会看到黑色图标 长条形尺寸,显示为无边框。

以下示例展示了定位前和定位后的应用 Android 15(API 级别 35)以及应用边衬区之前和之后。

<ph type="x-smartling-placeholder">
</ph>
一款以 Android 14 为目标平台且在 Android 设备上未处于无边框的应用 Android 15 设备。
一款以 Android 15(API 级别 35)为目标平台且采用无边框的应用 在 Android 15 设备上。不过,许多元素 栏、“三按钮”导航栏或刘海屏(由于 Android 15) 全屏强制措施。隐藏界面包含 Material 2 顶部应用栏、悬浮操作按钮和列表项。
如果应用以 Android 15(API 级别 35)为目标平台, Android 15 设备并应用边衬区,这样界面就不会 已隐藏。
检查应用是否已采用全屏的检查步骤

如果您的应用已经采用无边框且应用了边衬区, 基本未受影响,但下列情况除外。但即使您认为 您不会受到影响,但我们建议您测试自己的应用。

  • 您的非浮动窗口(例如 Activity)使用 SHORT_EDGESNEVERDEFAULT,而不是 LAYOUT_IN_DISPLAY_CUTOUT_MODE_ALWAYS。如果您的应用在启动时崩溃 可能是启动画面所致您可以升级核心 初始屏幕依赖项更改为 1.2.0-alpha01 或更高版本,或者设置 window.attributes.layoutInDisplayCutoutMode = WindowManager.LayoutInDisplayCutoutMode.always
  • 可能会有流量较低的屏幕显示被遮挡的界面。验证这些 访问较少的屏幕也不会显示被遮挡的界面。流量较低的屏幕包括: <ph type="x-smartling-placeholder">
      </ph>
    • 初始配置或登录屏幕
    • “设置”页面
如何检查应用尚未实现无边框

如果您的应用还没有全面屏,那么您很可能会受到影响。在 除了针对已经采用无边框的应用的情况之外, 请考虑以下事项:

  • 如果您的应用使用 Material 3 组件 ( androidx.compose.material3),例如 TopAppBarBottomAppBarNavigationBar,那么这些组件可能 会受到影响,因为它们会自动处理边衬区。
  • 如果您的应用使用 Material 2 组件 ( androidx.compose.material),那么这些组件 不会自动处理边衬区。不过,您可以使用边衬区 并手动应用这些设置在 androidx.compose.material 1.6.0 中 然后使用 windowInsets 参数手动应用边衬区 BottomAppBarTopAppBarBottomNavigationNavigationRail。 同样,对以下内容使用 contentWindowInsets 形参: Scaffold.
  • 如果您的应用使用视图和 Material 组件 (com.google.android.material),大多数基于 View 的 Material 如 BottomNavigationViewBottomAppBarNavigationRailViewNavigationView,处理边衬区,不需要 额外工作。但是,您需要将 android:fitsSystemWindows="true" 如果使用 AppBarLayout,则会发生此错误。
  • 对于自定义可组合项,请手动将边衬区作为内边距应用。如果您的 内容位于 Scaffold 内,因此您可以使用 Scaffold 来使用边衬区 内边距值。否则,使用 WindowInsets.
  • 如果您的应用使用的是视图和 BottomSheetSideSheet 或自定义 使用 ViewCompat.setOnApplyWindowInsetsListener。对于 RecyclerView,使用此监听器应用内边距,同时添加 clipToPadding="false".
检查应用是否必须提供自定义后台保护的注意事项

如果您的应用必须为“三按钮”导航或 状态栏,则应用应将可组合项或视图放在系统栏后面 使用 WindowInsets.Type#tappableElement() 获取三按钮 导航栏高度或 WindowInsets.Type#statusBars

其他无边框资源

请参阅无边框视图无边框 Compose 了解应用边衬区的其他注意事项。

已弃用的 API

以下 API 现已弃用:

稳定配置

如果您的应用以 Android 15(API 级别 35)或更高版本为目标平台,Configuration 否 不再包含系统栏。如果您使用 Configuration 类,您应将其替换为更好的 相应的 ViewGroupWindowInsetsWindowMetricsCalculator,具体取决于您的需求。

Configuration 从 API 1 开始提供。它通常从 Activity.onConfigurationChanged.它提供窗口密度、 屏幕方向和尺寸窗口大小的一个重要特征 Configuration 之前会排除系统栏。

配置大小通常用于选择资源,例如 /res/layout-h500dp,这仍然是一个有效的用例。但将其用于 但一直不建议进行布局计算。如果需要,您应该将 现在离它远去。您应该使用 Configuration 具体取决于您的应用场景。

如果使用它来计算布局,请使用适当的 ViewGroup,例如 CoordinatorLayoutConstraintLayout。如果使用该属性确定高度 ,请使用 WindowInsets。如果您想知道当前尺寸 ,请使用 computeCurrentWindowMetrics

以下列表介绍了受此变更影响的字段:

EnglishTextHeight 属性默认为 true

对于以 Android 15 为目标平台的应用,elegantTextHeight TextView 属性默认变为 true,将默认使用的紧凑字体替换为一些具有较大垂直指标的脚本,并且这种字体更易于阅读。紧凑字体的引入是为了防止破坏布局;Android 13(API 级别 33)允许文本布局利用 fallbackLineSpacing 属性拉伸垂直高度,以防止许多此类破坏。

在 Android 15 中,紧凑字体仍保留在系统中,因此您的应用可以将 elegantTextHeight 设置为 false,以获得与之前相同的行为,但即将在未来版本中提供支持。因此,如果您的应用支持以下文字:阿拉伯语、老挝语、缅甸、泰米尔语、古吉拉特语、卡纳达语、马拉雅拉姆语、奥里亚语、泰卢固语或泰语,请将 elegantTextHeight 设置为 true,以测试应用。

以 Android 14(API 级别 34)及更低版本为目标平台的应用的 elegantTextHeight 行为。
以 Android 15 为目标平台的应用的 elegantTextHeight 行为。

复杂字母形状的 TextView 宽度变化

In previous versions of Android, some cursive fonts or languages that have complex shaping might draw the letters in the previous or next character's area. In some cases, such letters were clipped at the beginning or ending position. Starting in Android 15, a TextView allocates width for drawing enough space for such letters and allows apps to request extra paddings to the left to prevent clipping.

Because this change affects how a TextView decides the width, TextView allocates more width by default if the app targets Android 15 or higher. You can enable or disable this behavior by calling the setUseBoundsForWidth API on TextView.

Because adding left padding might cause a misalignment for existing layouts, the padding is not added by default even for apps that target Android 15 or higher. However, you can add extra padding to preventing clipping by calling setShiftDrawingOffsetForStartOverhang.

The following examples show how these changes can improve text layout for some fonts and languages.

Standard layout for English text in a cursive font. Some of the letters are clipped. Here is the corresponding XML:

<TextView
    android:fontFamily="cursive"
    android:text="java" />
Layout for the same English text with additional width and padding. Here is the corresponding XML:

<TextView
    android:fontFamily="cursive"
    android:text="java"
    android:useBoundsForWidth="true"
    android:shiftDrawingOffsetForStartOverhang="true" />
Standard layout for Thai text. Some of the letters are clipped. Here is the corresponding XML:

<TextView
    android:text="คอมพิวเตอร์" />
Layout for the same Thai text with additional width and padding. Here is the corresponding XML:

<TextView
    android:text="คอมพิวเตอร์"
    android:useBoundsForWidth="true"
    android:shiftDrawingOffsetForStartOverhang="true" />

EditText 的语言区域感知型默认行高

在以前的 Android 版本中,文本布局拉伸了文本的高度,使其适应与当前语言区域匹配的字体的行高。例如,如果内容是日语,由于日语字体的行高比拉丁字体的行高略大,因此文本的高度就略大了。不过,尽管行高存在这些差异,但无论使用何种语言区域,EditText 元素的大小都是一致的,如下图所示:

三个表示 EditText 元素的框,这些框可以包含英语 (en)、日语 (ja) 和缅甸语 (my) 的文本。EditText 的高度相同,即使这两种语言的行高不同。

对于以 Android 15 为目标平台的应用,系统现在会为 EditText 预留最小行高,以匹配指定语言区域的参考字体,如下图所示:

三个表示 EditText 元素的框,这些框可以包含英语 (en)、日语 (ja) 和缅甸语 (my) 的文本。EditText 的高度现在包含空间,可适应这些语言字体的默认行高。

如果需要,您的应用可以通过将 useLocalePreferredLineHeightForMinimum 属性设置为 false 来恢复之前的行为,并且可以通过 Kotlin 和 Java 中的 setMinimumFontMetrics API 设置自定义最小行业指标。

摄像头和媒体

对于以 Android 15 或更高版本为目标平台的应用,Android 15 对相机和媒体行为做出了以下变更。

请求音频焦点的限制

以 Android 15 为目标平台的应用必须是顶级应用或运行前台服务,才能请求音频焦点。如果应用在不符合其中任何一项要求时尝试请求焦点,该调用将返回 AUDIOFOCUS_REQUEST_FAILED

您可以参阅管理音频焦点,详细了解音频焦点。

更新后的非 SDK 限制

Android 15 包含更新后的受限非 SDK 列表 基于与 Android 开发者之间的协作以及最新的 内部测试在限制使用非 SDK 接口之前,我们会尽可能确保有可用的公开替代方案。

如果您的应用并非以 Android 15 为目标平台,其中一些变更 可能不会立即对您产生影响。不过,虽然您的应用可以 访问某些非 SDK 接口 具体取决于应用的目标 API 级别,使用任何非 SDK 均可 方法或字段总是很有破坏应用的风险。

如果您不确定自己的应用是否使用了非 SDK 接口,可以 测试您的应用,找出答案。如果您的应用依赖于非 SDK 接口,则应开始计划迁移到 SDK 替代方案。 尽管如此,我们了解到,某些应用具有 非 SDK 接口。如果您无法找到使用非 SDK 的替代方案 应用某项功能的界面,您应该 请求新的公共 API

如需详细了解此 Android 版本中的变更,请参阅 Android 15 中有关限制非 SDK 接口的更新。如需全面了解有关非 SDK 接口的详细信息,请参阅对非 SDK 接口的限制